<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <title>40.30</title>
</head>

<body>
  <!-- Vùng header -->
  <div class="container">
    <div class="text-center">
      <h2>Danh sách người dùng đăng ký</h2>
    </div>
    <div class="form-group">
      <button class="btn btn-success" id="btn-add-voucher"><i class="fa fa-plus"></i>&nbsp; Thêm user</button>
    </div>
  </div>
  <!-- Vouche Data Table -->
  <div class="container">
    <table class="table table-bordered table-striped table-hover" id="users-table">
      <thead>
        <tr>
          <th>Id</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>
  </div>
</body>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gNAME_COL = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
  const gID_COL = 0;
  const gFIRSTNAME_COL = 1;
  const gLASTNAME_COL = 2;
  const gCOUNTRY_COL = 3;
  const gSUBJECT_COL = 4;
  const gCUSTOMER_TYPE_COL = 5;
  const gREGISTER_STATUS_COL = 6;
  const gACTION_COL = 7;
  var gDataUsersTable = $("#users-table").DataTable({
    columns: [
      { data: gNAME_COL[gID_COL] },
      { data: gNAME_COL[gFIRSTNAME_COL] },
      { data: gNAME_COL[gLASTNAME_COL] },
      { data: gNAME_COL[gCOUNTRY_COL] },
      { data: gNAME_COL[gSUBJECT_COL] },
      { data: gNAME_COL[gCUSTOMER_TYPE_COL] },
      { data: gNAME_COL[gREGISTER_STATUS_COL] },
      { data: gNAME_COL[gACTION_COL] },
    ],
    columnDefs: [
      {
        targets: gACTION_COL,
        defaultContent: `
                <div class= btn-group>
                <button class="btn btn-primary mr-2" id="btn-update-user">Sửa</button>
                <button class="btn btn-danger"  id="btn-delete-user">Xóa</button>
                </div>
                `
      }
    ]
  });

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {

    onPageLoading();
    //hàm thực thi khi ấn nút Sửa
    $("#users-table").on("click", "#btn-update-user", function () {
      onBtnUpdateUserClick(this)
    });
    //hàm thực thi khi ấn nút Xóa

    $("#users-table").on("click", "#btn-delete-user", function () {
      onBtnDeleteUserClick(this)
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm load trang
    function onPageLoading() {
      getUserList()
    }
    //hàm ấn nút Sửa:
    function onBtnUpdateUserClick(paramBtnUpdate) {
      var vTableRow = $(paramBtnUpdate).parents("tr");
      var vDataTableRow = gDataUsersTable.row(vTableRow);
      var vUserIdObj = vDataTableRow.data().id;
      console.log(vUserIdObj);

    }
    //hàm ấn nút Xóa:
    function onBtnDeleteUserClick(paramBtnDelete) {
      var vTableRow = $(paramBtnDelete).parents("tr");
      var vDataTableRow = gDataUsersTable.row(vTableRow);
      var vUserIdObj = vDataTableRow.data().id;
      console.log(vUserIdObj);

    }



    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm gọi api lấy danh sách user từ server:
    function getUserList() {
      $.ajax({
        url: "http://203.171.20.210:8080/crud-api/users/",
        type: "GET",
        success: function (paramRes) {
          console.log(paramRes)
          loadUserListToTable(paramRes)
        },
        error: function (paramErorr) {
          console.log(paramErorr.responseText)
        }
      });
    }
    //hàm load users list vào table:
    function loadUserListToTable(paramUserListObj) {
      gDataUsersTable.clear(),
      gDataUsersTable.rows.add(paramUserListObj),
      gDataUsersTable.draw()
    }
  });
</script>

</html>